###############################################################################
#
#    OERPScenario, OpenERP Functional Tests
#    Copyright 2009 Camptocamp SA
#
##############################################################################

# Features Generic tags (none for all)
##############################################################################
# Branch      # Module       # Processes                      # System
@addons       @account       @invoicing @reconciliation       @wizard

Feature: Test the pay invoice wizard
  In order to test the pay invoice wizard
  I want to see if the wizard take care of complex cases
  
  
    # Scenario specific tags
    ##############################################################################
    @bug511104 @bug496889 @bug497078 
    Scenario: Make payments in different currency with the pay invoice wizard
      Given I have recorded on the 1 jan 2009 a supplier invoice (in_invoice) of 1000,0 CHF without tax called MySupplierInvoicePayWizard
      When I press the validate button
      Then I should see the invoice MySupplierInvoicePayWizard open

      When I call the Pay invoice wizard
      And I partially pay 200.0 CHF.- on the 10 jan 2009
      Then I should see a residual amount of 800.00 CHF.-
      
      When I call the Pay invoice wizard
      And I partially pay 200.0 USD.- on the 11 jan 2009
      Then I should see a residual amount of 561.47 CHF.-
      
      When I call the Pay invoice wizard
      And I partially pay 200.0 EUR.- on the 12 jan 2009
      Then I should see a residual amount of 232.67 CHF.-
      
      When I call the Pay invoice wizard
      And I completely pay the residual amount in CHF on the 13 sep 2009
      Then I should see a residual amount of 0.0 CHF.-
      And I should see the invoice MySupplierInvoicePayWizard paid
      And the payment tabs should contain 5 lines
      And the entries into the invoice's reconciliation must be balanced
    
    @bug511104  
    Scenario: Make simple payments with the pay invoice wizard
    
      Given I have recorded on the 1 jan 2009 a supplier invoice (in_invoice) of 450,0 USD without tax called MySupplierInvoicePayWizard
      When I press the validate button
      Then I should see the invoice MySupplierInvoicePayWizard open
      
      When I call the Pay invoice wizard
      And I completely pay the residual amount in USD on the 2 feb 2009
      Then I should see a residual amount of 0.0 USD.-
      And I should see the invoice MySupplierInvoicePayWizard paid
      And I should see amount in currency equal to 0
      
      Given I have recorded on the 1 jan 2009 a supplier invoice (in_invoice) of 450,0 USD without tax called MySupplierInvoicePayWizard2
      When I press the validate button
      Then I should see the invoice MySupplierInvoicePayWizard2 open
      
      When I call the Pay invoice wizard
      And I partially pay 200.0 USD.- on the 2 feb 2009
      Then I should see a residual amount of 250.0 USD.-
      
      When I call the Pay invoice wizard
      And I completely pay the residual amount in CHF on the 2 feb 2009
      Then I should see a residual amount of 0.0 USD.-
      And I should see the invoice MySupplierInvoicePayWizard2 paid
    
    @bug511104
    Scenario: Make payments to test the write-off with the pay invoice wizard
      Given I have recorded on the 1 jan 2009 a supplier invoice (in_invoice) of 450,0 USD without tax called MySupplierInvoicePayWizard3
      When I press the validate button
      Then I should see the invoice MySupplierInvoicePayWizard3 open

      When I call the Pay invoice wizard
      And I partially pay 300.0 CHF.- on the 2 feb 2009
      Then I should see a residual amount of 198.45 USD.-
      
      When I call the Pay invoice wizard
      And I partially pay 100.0 USD.- on the 9 sept 2009
      Then I should see a residual amount of 98.45 USD.-
      
      When I call the Pay invoice wizard
      And I finally paid 50.0 USD.- on the 9 sept 2009 as the last and full payment
      
      Then I should see a residual amount of 0.0 USD.-
      And I should see the invoice MySupplierInvoicePayWizard3 paid
      And the payment tabs should contain 4 lines
      And the entries into the invoice's reconciliation must be balanced
