###############################################################################
#
#    OERPScenario, OpenERP Functional Tests
#    Copyright 2009 Camptocamp SA
#
##############################################################################

# Features Generic tags (none for all)
##############################################################################

# Branch      # Module       # Processes     # System
@addons       @base

Feature: Control the base module
  In order to test the basic features of the base module
  I want to make some basic tests

  # Scenario specific tags
  ##############################################################################
  @properties
  Scenario: Validate the model ir.property into the DB
    Given I check the integrity of ir.property named property_product_pricelist
    Then I check the value of ir.property and it should not start with a space


  # Scenario specific tags
  ##############################################################################  
  @partner
  Scenario: Validate the partner creation
    Given I want to create a partner named automatedtest with default receivable account 
    Then I get a receivable account
    And I should get a partner id

  # Scenario specific tags
  ##############################################################################  
  Scenario: Validate specific views
    Given I take the following models:
        |Name|
        |AccountInvoice|
        |AccountAccount|
        |AccountMoveLine|
        |AccountBankStatement|
        |AccountJournal|
        |ResPartner|
        |ResPartnerAddress|
        |SaleOrder|
        |SaleOrderLine|
        |ProductProduct|
    When I call the existing tree views I should not get an error
    And I call the existing form views I should not get an error

  # Scenario specific tags
  ##############################################################################
  Scenario: Validate all installed views
    Given I take all installed models
    When I call the existing tree views I should not get an error
    And I call the existing form views I should not get an error
